# Estimating transaction fees

Wallet-as-a-Service (Palisade)'s Transaction Fee Estimation API allows customers to preview network fees before executing transfers of their digital assets. See the [Wallet-as-a-Service (Palisade) API](/products/wallet/api-docs/palisade-api/palisade-api) for details.

As a result, customers can properly budget for transaction costs and choose the optimal fee level based on the urgency of the transaction.

## How to estimate transaction fees via the API

Use this new endpoint to get accurate fee estimates for transactions across supported blockchains:


```
POST /v2/transactions/transfer/estimate-fee
```

### Example Request Body:


```json
{
    "blockchain": "ETHEREUM",
    "symbol": "USDT",
    "contract": "0xdAC17F958D2ee523a2206206994597C13D831ec7",
    "originAddress": "0x55502b9d5a68b0F8a48384352295BeD968aD8AA4"
}
```

### Example Response:


```json
{
    "evm": {
        "gasPrice": "300000000",
        "baseFee": "100000000",
        "priorityFee": "200000000",
        "gasLimit": "65156"
    },
    "networkFees": {
        "average": "0.0000195468",
        "fast": "0.0001042496",
        "fastest": "0.0001694056",
        "slow": "0.0000195468",
        "slowest": "0.0000065156"
    }
}
```

As you can see in the Example Response, the API will return 5 speed tiers (slowest to fastest) and their associated fees. Customers have the option to pay a higher fee for the transaction to be processed more quickly.

For Ethereum and compatible chains, the API will also return detailed gas information including:

* Gas price (in gwei)
* Base fee (in gwei)
* Priority fee (in gwei)
* Estimated gas limit.


Once customers have previewed the fee options, they can then specify their desired network fee in the transfer API. See the [Wallet-as-a-Service (Palisade) API reference](/products/wallet/api-docs/palisade-api/palisade-api) for more details.

API only
This feature is currently API only. It will be available on the Wallet-as-a-Service (Palisade) UI soon.